VTK: vtkThreadedCompositeDataPipeline Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
vtkThreadedCompositeDataPipeline Class Reference

Executive that works in parallel. More...

`#include <vtkThreadedCompositeDataPipeline.h>`

Inheritance diagram for vtkThreadedCompositeDataPipeline:
[legend]
Collaboration diagram for vtkThreadedCompositeDataPipeline:
[legend]

## Public Types
typedef vtkCompositeDataPipeline | Superclass
Public Types inherited from vtkCompositeDataPipeline
typedef vtkStreamingDemandDrivenPipeline | Superclass
Public Types inherited from vtkStreamingDemandDrivenPipeline
typedef vtkDemandDrivenPipeline | Superclass
Public Types inherited from vtkDemandDrivenPipeline
typedef vtkExecutive | Superclass
Public Types inherited from vtkExecutive
enum | { RequestUpstream , RequestDownstream }
enum | { BeforeForward , AfterForward }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkThreadedCompositeDataPipeline * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | CallAlgorithm (vtkInformation *request, int direction, vtkInformationVector **inInfo, vtkInformationVector *outInfo) override
| An API to CallAlgorithm that allows you to pass in the info objects to be used. More...
Public Member Functions inherited from vtkCompositeDataPipeline
vtkCompositeDataPipeline * | NewInstance () const
vtkDataObject * | GetCompositeOutputData (int port)
| Returns the data object stored with the DATA_OBJECT() in the output port. More...
vtkDataObject * | GetCompositeInputData (int port, int index, vtkInformationVector **inInfoVec)
| Returns the data object stored with the DATA_OBJECT() in the input port. More...
Public Member Functions inherited from vtkStreamingDemandDrivenPipeline
vtkStreamingDemandDrivenPipeline * | NewInstance () const
vtkTypeBool | ProcessRequest (vtkInformation *request, vtkInformationVector **inInfo, vtkInformationVector *outInfo) override
| Generalized interface for asking the executive to fulfill update requests. More...
virtual vtkTypeBool | Update (int port, vtkInformationVector *requests)
| This method enables the passing of data requests to the algorithm to be used during execution (in addition to bringing a particular port up-to-date). More...
int | PropagateUpdateExtent (int outputPort)
| Propagate the update request from the given output port back through the pipeline. More...
vtkTypeBool | Update () override
| Bring the outputs up-to-date. More...
vtkTypeBool | Update (int port) override
| Bring the outputs up-to-date. More...
virtual vtkTypeBool | UpdateWholeExtent ()
| Bring the outputs up-to-date. More...
int | PropagateTime (int outputPort)
| Propagate time through the pipeline. More...
int | UpdateTimeDependentInformation (int outputPort)
| Propagate time through the pipeline. More...
int | SetRequestExactExtent (int port, int flag)
| This request flag indicates whether the requester can handle more data than requested for the given port. More...
int | GetRequestExactExtent (int port)
| This request flag indicates whether the requester can handle more data than requested for the given port. More...
Public Member Functions inherited from vtkDemandDrivenPipeline
vtkDemandDrivenPipeline * | NewInstance () const
int | ComputePipelineMTime (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int requestFromOutputPort, vtkMTimeType *mtime) override
| Implement the pipeline modified time request. More...
virtual int | SetReleaseDataFlag (int port, vtkTypeBool n)
| Set whether the given output port releases data when it is consumed. More...
virtual vtkTypeBool | GetReleaseDataFlag (int port)
| Get whether the given output port releases data when it is consumed. More...
virtual int | UpdatePipelineMTime ()
| Bring the PipelineMTime up to date. More...
int | UpdateDataObject () override
| Bring the output data object's existence up to date. More...
int | UpdateInformation () override
| Bring the output information up to date. More...
virtual int | UpdateData (int outputPort)
| Bring the output data up to date. More...
virtual vtkMTimeType | GetPipelineMTime ()
| Get the PipelineMTime for this exective. More...
Public Member Functions inherited from vtkExecutive
vtkExecutive * | NewInstance () const
vtkAlgorithm * | GetAlgorithm ()
| Get the algorithm to which this executive has been assigned. More...
int | GetNumberOfInputConnections (int port)
| Get the number of input connections on the given port. More...
virtual vtkInformation * | GetOutputInformation (int port)
| Get the pipeline information object for the given output port. More...
vtkInformationVector * | GetOutputInformation ()
| Get the pipeline information object for all output ports. More...
vtkInformation * | GetInputInformation (int port, int connection)
| Get the pipeline information for the given input connection. More...
vtkInformationVector * | GetInputInformation (int port)
| Get the pipeline information vectors for the given input port. More...
vtkInformationVector ** | GetInputInformation ()
| Get the pipeline information vectors for all inputs. More...
vtkExecutive * | GetInputExecutive (int port, int connection)
| Get the executive managing the given input connection. More...
int | GetNumberOfInputPorts ()
| Get the number of input/output ports for the algorithm associated with this executive. More...
int | GetNumberOfOutputPorts ()
| Get the number of input/output ports for the algorithm associated with this executive. More...
virtual vtkDataObject * | GetOutputData (int port)
| Get/Set the data object for an output port of the algorithm. More...
virtual void | SetOutputData (int port, vtkDataObject *, vtkInformation *info)
| Get/Set the data object for an output port of the algorithm. More...
virtual void | SetOutputData (int port, vtkDataObject *)
| Get/Set the data object for an output port of the algorithm. More...
virtual vtkDataObject * | GetInputData (int port, int connection)
| Get the data object for an input port of the algorithm. More...
virtual vtkDataObject * | GetInputData (int port, int connection, vtkInformationVector **inInfoVec)
| Get the data object for an input port of the algorithm. More...
void | SetSharedInputInformation (vtkInformationVector **inInfoVec)
| Get the output port that produces the given data object. More...
void | SetSharedOutputInformation (vtkInformationVector *outInfoVec)
| Get the output port that produces the given data object. More...
bool | UsesGarbageCollector () const override
| Participate in garbage collection. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkThreadedCompositeDataPipeline * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkThreadedCompositeDataPipeline * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkCompositeDataPipeline
static vtkCompositeDataPipeline * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCompositeDataPipeline * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | LOAD_REQUESTED_BLOCKS ()
| An integer key that indicates to the source to load all requested blocks specified in UPDATE_COMPOSITE_INDICES. More...
static vtkInformationObjectBaseKey * | COMPOSITE_DATA_META_DATA ()
| COMPOSITE_DATA_META_DATA is a key placed in the output-port information by readers/sources producing composite datasets. More...
static vtkInformationIntegerVectorKey * | UPDATE_COMPOSITE_INDICES ()
| UPDATE_COMPOSITE_INDICES is a key placed in the request to request a set of composite indices from a reader/source producing composite dataset. More...
static vtkInformationDoubleKey * | BLOCK_AMOUNT_OF_DETAIL ()
| BLOCK_AMOUNT_OF_DETAIL is a key placed in the information about a multi-block dataset that indicates how complex the block is. More...
Static Public Member Functions inherited from vtkStreamingDemandDrivenPipeline
static vtkStreamingDemandDrivenPipeline * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkStreamingDemandDrivenPipeline * | SafeDownCast (vtkObjectBase *o)
static vtkInformationRequestKey * | REQUEST_UPDATE_EXTENT ()
| Key defining a request to propagate the update extent upstream. More...
static vtkInformationRequestKey * | REQUEST_UPDATE_TIME ()
| Key defining a request to propagate the update extent upstream. More...
static vtkInformationRequestKey * | REQUEST_TIME_DEPENDENT_INFORMATION ()
| Key defining a request to make sure the meta information is up to date. More...
static vtkInformationIntegerKey * | CONTINUE_EXECUTING ()
| Key for an algorithm to store in a request to tell this executive to keep executing it. More...
static vtkInformationIntegerKey * | UPDATE_EXTENT_INITIALIZED ()
| Keys to store an update request in pipeline information. More...
static vtkInformationIntegerVectorKey * | UPDATE_EXTENT ()
static vtkInformationIntegerKey * | UPDATE_PIECE_NUMBER ()
static vtkInformationIntegerKey * | UPDATE_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | UPDATE_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationIntegerVectorKey * | COMBINED_UPDATE_EXTENT ()
| Key for combining the update extents requested by all consumers, so that the final extent that is produced satisfies all consumers. More...
static vtkInformationIntegerVectorKey * | WHOLE_EXTENT ()
| Key to store the whole extent provided in pipeline information. More...
static vtkInformationIntegerKey * | UNRESTRICTED_UPDATE_EXTENT ()
| This is set if the update extent is not restricted to the whole extent, for sources that can generate an extent of any requested size. More...
static vtkInformationIntegerKey * | EXACT_EXTENT ()
| Key to specify the request for exact extent in pipeline information. More...
static vtkInformationDoubleVectorKey * | TIME_STEPS ()
| Key to store available time steps. More...
static vtkInformationDoubleVectorKey * | TIME_RANGE ()
| Key to store available time range for continuous sources. More...
static vtkInformationDoubleKey * | UPDATE_TIME_STEP ()
| Update time steps requested by the pipeline. More...
static vtkInformationIntegerKey * | TIME_DEPENDENT_INFORMATION ()
| Whether there are time dependent meta information if there is, the pipeline will perform two extra passes to gather the time dependent information. More...
static vtkInformationDoubleVectorKey * | BOUNDS ()
| key to record the bounds of a dataset. More...
static int | SetWholeExtent (vtkInformation *, int extent[6])
| Set/Get the whole extent of an output port. More...
static void | GetWholeExtent (vtkInformation *, int extent[6])
| Set/Get the whole extent of an output port. More...
static int * | GetWholeExtent (vtkInformation *)
| Set/Get the whole extent of an output port. More...
static void | GetUpdateExtent (vtkInformation *, int extent[6])
| Get/Set the update extent for output ports that use 3D extents. More...
static int * | GetUpdateExtent (vtkInformation *)
| Get/Set the update extent for output ports that use 3D extents. More...
static int | GetUpdatePiece (vtkInformation *)
| Set/Get the update piece, update number of pieces, and update number of ghost levels for an output port. More...
static int | GetUpdateNumberOfPieces (vtkInformation *)
| Set/Get the update piece, update number of pieces, and update number of ghost levels for an output port. More...
static int | GetUpdateGhostLevel (vtkInformation *)
| Set/Get the update piece, update number of pieces, and update number of ghost levels for an output port. More...
Static Public Member Functions inherited from vtkDemandDrivenPipeline
static vtkDemandDrivenPipeline * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDemandDrivenPipeline * | SafeDownCast (vtkObjectBase *o)
static vtkInformationRequestKey * | REQUEST_DATA_OBJECT ()
| Key defining a request to make sure the output data objects exist. More...
static vtkInformationRequestKey * | REQUEST_INFORMATION ()
| Key defining a request to make sure the output information is up to date. More...
static vtkInformationRequestKey * | REQUEST_DATA ()
| Key defining a request to make sure the output data are up to date. More...
static vtkInformationRequestKey * | REQUEST_DATA_NOT_GENERATED ()
| Key defining a request to mark outputs that will NOT be generated during a REQUEST_DATA. More...
static vtkInformationIntegerKey * | RELEASE_DATA ()
| Key to specify in pipeline information the request that data be released after it is used. More...
static vtkInformationIntegerKey * | DATA_NOT_GENERATED ()
| Key to store a mark for an output that will not be generated. More...
static vtkDataObject * | NewDataObject (const char *type)
| Create (New) and return a data object of the given type. More...
Static Public Member Functions inherited from vtkExecutive
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExecutive * | SafeDownCast (vtkObjectBase *o)
static vtkInformationExecutivePortKey * | PRODUCER ()
| Information key to store the executive/port number producing an information object. More...
static vtkInformationExecutivePortVectorKey * | CONSUMERS ()
| Information key to store the executive/port number pairs consuming an information object. More...
static vtkInformationIntegerKey * | FROM_OUTPUT_PORT ()
| Information key to store the output port number from which a request is made. More...
static vtkInformationIntegerKey * | ALGORITHM_BEFORE_FORWARD ()
| Keys to program vtkExecutive::ProcessRequest with the default behavior for unknown requests. More...
static vtkInformationIntegerKey * | ALGORITHM_AFTER_FORWARD ()
| Keys to program vtkExecutive::ProcessRequest with the default behavior for unknown requests. More...
static vtkInformationIntegerKey * | ALGORITHM_DIRECTION ()
| Keys to program vtkExecutive::ProcessRequest with the default behavior for unknown requests. More...
static vtkInformationIntegerKey * | FORWARD_DIRECTION ()
| Keys to program vtkExecutive::ProcessRequest with the default behavior for unknown requests. More...
static vtkInformationKeyVectorKey * | KEYS_TO_COPY ()
| Keys to program vtkExecutive::ProcessRequest with the default behavior for unknown requests. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkThreadedCompositeDataPipeline ()
| ~vtkThreadedCompositeDataPipeline () override
void | ExecuteEach (vtkCompositeDataIterator *iter, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int compositePort, int connection, vtkInformation *request, std::vector< vtkSmartPointer< vtkCompositeDataSet >> &compositeOutput) override
Protected Member Functions inherited from vtkCompositeDataPipeline
| vtkCompositeDataPipeline ()
| ~vtkCompositeDataPipeline () override
int | ForwardUpstream (vtkInformation *request) override
virtual int | ForwardUpstream (int i, int j, vtkInformation *request)
void | CopyDefaultInformation (vtkInformation *request, int direction, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
virtual void | PushInformation (vtkInformation *)
virtual void | PopInformation (vtkInformation *)
int | ExecuteDataObject (vtkInformation *request, vtkInformationVector **inInfo, vtkInformationVector *outInfo) override
int | ExecuteData (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | ExecuteDataStart (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
int | NeedToExecuteData (int outputPort, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
virtual int | CheckCompositeData (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec)
virtual void | ExecuteSimpleAlgorithm (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int compositePort)
std::vector< vtkDataObject * > | ExecuteSimpleAlgorithmForBlock (vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, vtkInformation *inInfo, vtkInformation *request, vtkDataObject *dobj)
bool | ShouldIterateOverInput (vtkInformationVector **inInfoVec, int &compositePort)
int | InputTypeIsValid (int port, int index, vtkInformationVector **inInfoVec) override
void | ResetPipelineInformation (int port, vtkInformation *) override
std::vector< vtkSmartPointer< vtkDataObject > > | CreateOutputCompositeDataSet (vtkCompositeDataSet *input, int compositePort, int numOutputPorts)
| Tries to create the best possible composite data output for the given input and non-composite algorithm output. More...
void | MarkOutputsGenerated (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
int | NeedToExecuteBasedOnCompositeIndices (vtkInformation *outInfo)
Protected Member Functions inherited from vtkStreamingDemandDrivenPipeline
| vtkStreamingDemandDrivenPipeline ()
| ~vtkStreamingDemandDrivenPipeline () override
virtual int | NeedToExecuteBasedOnTime (vtkInformation *outInfo, vtkDataObject *dataObject)
int | ExecuteInformation (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | CopyDefaultInformation (vtkInformation *request, int direction, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
virtual int | VerifyOutputInformation (int outputPort, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec)
int | NeedToExecuteData (int outputPort, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | ExecuteDataStart (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | ExecuteDataEnd (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | MarkOutputsGenerated (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec) override
void | ResetPipelineInformation (int port, vtkInformation *) override
Protected Member Functions inherited from vtkDemandDrivenPipeline
| vtkDemandDrivenPipeline ()
| ~vtkDemandDrivenPipeline () override
virtual int | CheckDataObject (int port, vtkInformationVector *outInfo)
int | InputCountIsValid (vtkInformationVector **)
int | InputCountIsValid (int port, vtkInformationVector **)
int | InputTypeIsValid (vtkInformationVector **)
int | InputTypeIsValid (int port, vtkInformationVector **)
int | InputFieldsAreValid (vtkInformationVector **)
int | InputFieldsAreValid (int port, vtkInformationVector **)
virtual int | InputFieldsAreValid (int port, int index, vtkInformationVector **)
int | DataSetAttributeExists (vtkDataSetAttributes *dsa, vtkInformation *field)
int | FieldArrayExists (vtkFieldData *data, vtkInformation *field)
int | ArrayIsValid (vtkAbstractArray *array, vtkInformation *field)
int | InputIsOptional (int port)
int | InputIsRepeatable (int port)
Protected Member Functions inherited from vtkExecutive
| vtkExecutive ()
| ~vtkExecutive () override
int | InputPortIndexInRange (int port, const char *action)
int | OutputPortIndexInRange (int port, const char *action)
int | CheckAlgorithm (const char *method, vtkInformation *request)
bool | CheckAbortedInput (vtkInformationVector **inInfoVec)
| Checks to see if an inputs have ABORTED set. More...
virtual int | ForwardDownstream (vtkInformation *request)
void | ReportReferences (vtkGarbageCollector *) override
virtual void | SetAlgorithm (vtkAlgorithm *algorithm)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Friends
class | ProcessBlock

## Additional Inherited Members
Static Protected Member Functions inherited from vtkCompositeDataPipeline
static vtkInformationIntegerKey * | SUPPRESS_RESET_PI ()
static vtkInformationIntegerVectorKey * | DATA_COMPOSITE_INDICES ()
| COMPOSITE_INDICES() is put in the output information by the executive if the request has UPDATE_COMPOSITE_INDICES() using the generated composite dataset's structure. More...
Static Protected Member Functions inherited from vtkStreamingDemandDrivenPipeline
static vtkInformationDoubleKey * | PREVIOUS_UPDATE_TIME_STEP ()
| Keep track of the update time request corresponding to the previous executing. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkCompositeDataPipeline
int | InLocalLoop
vtkInformation * | InformationCache
vtkInformation * | GenericRequest
vtkInformation * | InformationRequest
Protected Attributes inherited from vtkStreamingDemandDrivenPipeline
int | ContinueExecuting
vtkInformation * | UpdateExtentRequest
vtkInformation * | UpdateTimeRequest
vtkInformation * | TimeDependentInformationRequest
vtkInformationIterator * | InformationIterator
int | LastPropogateUpdateExtentShortCircuited
Protected Attributes inherited from vtkDemandDrivenPipeline
vtkMTimeType | PipelineMTime
vtkTimeStamp | DataObjectTime
vtkTimeStamp | InformationTime
vtkTimeStamp | DataTime
vtkInformation * | InfoRequest
vtkInformation * | DataObjectRequest
vtkInformation * | DataRequest
Protected Attributes inherited from vtkExecutive
vtkAlgorithm * | Algorithm
int | InAlgorithm
vtkInformationVector ** | SharedInputInformation
vtkInformationVector * | SharedOutputInformation
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Executive that works in parallel.

vtkThreadedCompositeDataPipeline processes a composite data object in parallel using the SMP framework. It does this by creating a vector of data objects (the pieces of the composite data) and processing them using vtkSMPTools::For. Note that this requires that the algorithm implement all pipeline passes in a re-entrant way. It should store/retrieve all state changes using input and output information objects, which are unique to each thread.

Tests:
  vtkThreadedCompositeDataPipeline (Tests)

Definition at line 29 of file vtkThreadedCompositeDataPipeline.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkCompositeDataPipeline vtkThreadedCompositeDataPipeline::Superclass

Definition at line 34 of file vtkThreadedCompositeDataPipeline.h.

## Constructor & Destructor Documentation

## ◆ vtkThreadedCompositeDataPipeline()

vtkThreadedCompositeDataPipeline::vtkThreadedCompositeDataPipeline | ( |  | ) |
| protected

## ◆ ~vtkThreadedCompositeDataPipeline()

vtkThreadedCompositeDataPipeline::~vtkThreadedCompositeDataPipeline | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkThreadedCompositeDataPipeline* vtkThreadedCompositeDataPipeline::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkThreadedCompositeDataPipeline::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkThreadedCompositeDataPipeline::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkCompositeDataPipeline.

## ◆ SafeDownCast()

static vtkThreadedCompositeDataPipeline* vtkThreadedCompositeDataPipeline::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkThreadedCompositeDataPipeline::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkCompositeDataPipeline.

## ◆ NewInstance()

vtkThreadedCompositeDataPipeline* vtkThreadedCompositeDataPipeline::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkThreadedCompositeDataPipeline::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkCompositeDataPipeline.

## ◆ CallAlgorithm()

int vtkThreadedCompositeDataPipeline::CallAlgorithm | ( | vtkInformation * | request,
|  | int | direction,
|  | vtkInformationVector ** | inInfo,
|  | vtkInformationVector * | outInfo
| ) |  |
| overridevirtual

An API to CallAlgorithm that allows you to pass in the info objects to be used.

Reimplemented from vtkExecutive.

## ◆ ExecuteEach()

void vtkThreadedCompositeDataPipeline::ExecuteEach | ( | vtkCompositeDataIterator * | iter,
|  | vtkInformationVector ** | inInfoVec,
|  | vtkInformationVector * | outInfoVec,
|  | int | compositePort,
|  | int | connection,
|  | vtkInformation * | request,
|  | std::vector< vtkSmartPointer< vtkCompositeDataSet >> & | compositeOutput
| ) |  |
| overrideprotectedvirtual

Reimplemented from vtkCompositeDataPipeline.

## Friends And Related Function Documentation

## ◆ ProcessBlock

friend class ProcessBlock
| friend

Definition at line 54 of file vtkThreadedCompositeDataPipeline.h.

The documentation for this class was generated from the following file:

- Common/ExecutionModel/vtkThreadedCompositeDataPipeline.h